/*
 * Scratchbox Remote Shell
 * Copyright (c) 2003 Timo Savola <timo.savola@movial.fi>
 *
 * sbrsh is licensed under GPL.
 * You can read the full license at http://www.gnu.org/licenses/gpl.txt
 */

#ifndef BUFFER_H
#define BUFFER_H

#include "types.h"

/** Normal buffer size. */
#define BUFFER_SIZE 4096

/** Dynamic buffer of arbitrary data. */
typedef struct {
	size_t start;
	size_t end;
	bool_t eof;
	size_t mem_size;
	uint8_t *mem;
} buffer_t;

#define buf_size(buf) ((buf)->end - (buf)->start)

/** Is buffer empty and doesn't have EOF? */
#define buf_is_empty(buf) ((buf)->end == 0 && (buf)->eof == FALSE)

/** This closes the file when all data from the buffer is written out. */
#define buf_set_eof(buf)  ((buf)->eof = TRUE)

extern int buf_init(buffer_t *buf);
extern void buf_free(buffer_t *buf);
extern ssize_t buf_read_in(buffer_t *buf, int fd, size_t len);
extern ssize_t buf_write_out(buffer_t *buf, int *fd);

#endif
